<?php

namespace STM\Person\Position;

use \Exception;
use STM\StmFactory;

/**
 * Test class for PersonPositionValidator.
 * Generated by PHPUnit on 2012-03-28 at 18:02:54.
 * @group person
 */
class PersonPositionValidatorTest extends \PHPUnit_Framework_TestCase {

    protected function setUp() {
        PersonPositionValidator::init();
    }

    public function testCheck_create() {
        $sport = StmFactory::find()->Sport->findById(1);
        if ($sport) {
            parent::assertTrue(PersonPositionValidator::checkCreate(array('position' => 'My position 125/*', 'abbrevation' => 'M', 'sport' => $sport)));
        }
        $this->assert_bad_arguments('checkCreate', array('position' => 'm', 'abbrevation' => 'M', 'sport' => StmFactory::find()->Sport->findById(1)));
        $this->assert_bad_arguments('checkCreate', array('position' => 'Pos*/*/*/*/444', 'abbrevation' => 'Too long', 'sport' => StmFactory::find()->Sport->findById(1)));
        $this->assert_bad_arguments('checkCreate', array('position' => 'makov', 'abbrevation' => 'M', 'sport' => new Exception()));
        $this->assert_bad_arguments('checkCreate', null);
        $this->assert_bad_arguments('checkCreate', array('sport' => 1));
    }

    public function testCheck_update() {        
        // compared object must be set
        $this->assert_bad_arguments('checkUpdate', array('position' => 'My position 125/*', 'abbrevation' => 'M', 'sport' => StmFactory::find()->Sport->findById(1)));
        // same as testCheck_create, only values must be different from current value
        foreach (StmFactory::find()->PersonPosition->findAll() as $position) {                                            
            $current_name = $position->__toString();
            $current_abbrevation = $position->getAbbrevation();
            $current_sport = StmFactory::find()->Sport->findById($position->getIdSport());
            PersonPositionValidator::setPosition($position);            
            $this->assert_bad_arguments('checkUpdate', array('position' => $current_name, 'abbrevation' => $current_abbrevation, 'sport' => $current_sport));
            PersonPositionValidator::resetPosition();
        }
    }
    
    private function assert_bad_arguments($method, $data) {
        PersonPositionValidator::init();
        parent::assertFalse(PersonPositionValidator::$method($data));
        PersonPositionValidator::init();
    }
}

?>